/**
 *    author:  tourist
 *    created: 26.10.2022 07:36:10       
**/
#include <bits/stdc++.h>

using namespace std;

#ifdef LOCAL
#include "algo/debug.h"
#else
#define debug(...) 42
#endif

int main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
  int n;
  cin >> n;
  vector<int> a(n);
  for (int i = 0; i < n; i++) {
    cin >> a[i];
  }
  vector<int> b(n);
  for (int i = 0; i < n; i++) {
    b[i] = (i == 0 ? a[i] : min(b[i - 1], a[i]));
  }
  long long ans = accumulate(b.begin(), b.end(), 0LL);
  int q;
  cin >> q;
  for (int it = 0; it <= q; it++) {
    cout << ans << '\n';
    if (it == q) {
      break;
    }
    int op, x;
    cin >> op >> x;
    if (op == 1) {
      a[x] += 1;
    } else {
      assert(a[x] > 0);
      a[x] -= 1;
    }
    while (x < n) {
      int new_b = (x == 0 ? a[x] : min(b[x - 1], a[x]));
      if (new_b == b[x]) {
        break;
      }
      ans += new_b - b[x];
      b[x] = new_b;
      x += 1;
    }
  }
  return 0;
}
